/*

  gLogger
    
	Martin Matysiak, 2008
	    mail@k621.de

  Version 1.01

*/

#define F_CPU 4000000UL

#define LED_PORT PORTC
#define LED_WARN PC1
#define LED_STAT PC0

#define LEDCODE_OFF LED_PORT &= ~((1 << LED_WARN) | (1 << LED_STAT)) //0x00
#define LEDCODE_OK LED_PORT = (LED_PORT & ~(1 << LED_WARN)) | (1 << LED_STAT) //0x01
#define LEDCODE_WARNING LED_PORT = (LED_PORT & ~(1 << LED_STAT)) | (1 << LED_WARN) //0x02
#define LEDCODE_PROCESSING LED_PORT |= (1 << LED_WARN) | (1 << LED_STAT) //0x03
#define LEDCODE_BLINK LED_PORT ^= (1 << LED_STAT)

#include <avr/io.h>
#include <util/delay.h>
#include <gps.h>
#include <mmc.h>
#include <fat16.h>
 
struct {
	unsigned record:1;
	unsigned keydown:2;
} status;

int main (void) {
 
	//Ports definieren
	DDRC = 0x03;
	LEDCODE_PROCESSING;

	//SD Karte + FAT initalisieren
	if ((mmc_init() != 0) || (InitFat16() != 0)) {
		LEDCODE_WARNING;
		while(1);
	}

	LEDCODE_OK;

	//Log-Datei suchen und Position merken
	File logFile;
	//unsigned char * fileName = (unsigned char *)"log.csv";

	/* if (fexist_(fileName,&logFile) != 1) {
		LEDCODE_WARNING;
		while(1) {
		}
	} */

	//GPS Modul initalisieren, auf Fix warten
	gps_init();

	//Variablen initalisieren
	LEDCODE_OFF;
	status.record = 0;
	char incoming[128];

	//Hauptschleife
	while(1) {
		if (~PINC & (1 << PINC2)) {
			LEDCODE_WARNING;
			if (!status.keydown) {
				status.keydown = 1;
				_delay_ms(2000);
			} else {
				LEDCODE_PROCESSING;
				status.record = !status.record;
				if(status.record) {
					fopen_((unsigned char*)"log.nmea",'a',&logFile);
					fputs_(&logFile,"***START***");
				} else {
					fputs_(&logFile,"***STOP***");
					fclose_(&logFile);
				}
				_delay_ms(500);
				LEDCODE_OFF;
			}
		} else {
			status.keydown = 0;
			LEDCODE_OFF;
		}

		if (status.record) {
		    gps_get_nmea(incoming, sizeof(incoming));
			fputs_(&logFile, incoming);
			LEDCODE_BLINK;
		} else {
			_delay_ms(950);
			LEDCODE_WARNING;
			_delay_ms(50);
			LEDCODE_OFF;
		}
	}
 
	/* wird nie erreicht */
	return 0;
}
